#ifndef TCPTO_H
#define TCPTO_H
#include "ipalloc.h"

#define TCPTO_BUFSIZ 1024

/* persistency structure: record 
struct tcpto {		
  unsigned char af;        --  1 byte -- IPv4: x'2' / IPv6: x'a' (10)
  unsigned char nul[3];    --  3 byte
  unsigned char errorcount --  1 byte -- if err_timeout || err_conrefused || err_proto (TLS)
  unsigned char nul[3];    --  3 byte
  unsigned long when;      --  8 byte		
  union {
    struct ip_address ip;
    struct ip6_address ip6;
    unsigned char nul[16];  -- 16 byte -- IPv4: filled up with '.' = x'2e'
  } addr;		
};               total:       32 byte
*/

int tcpto(struct ip_mx *);
void tcpto_err(struct ip_mx *, int);
void tcpto_clean();

#endif
