#include <unistd.h>
#include "logmsg.h"
#include "buffer.h"
#include "lock.h"
#include "open.h"
#include "auto_queue.h"
#include "exit.h"
#include "qmail.h"

#define WHO "qmail-tcpok"

char buf[BUFSIZE_LINE]; /* XXX: must match size in tcpto_clean.c, tcpto.c */
buffer bo;

int main()
{
  int fd;
  int i;

  if (chdir(auto_queue) == -1)
    logmsg(WHO,111,FATAL,B("unable to chdir to: ",auto_queue));
  if (chdir("queue") == -1)
    logmsg(WHO,111,FATAL,B("unable to chdir to: ",auto_queue,"/queue"));
  if (chdir("lock") == -1)
    logmsg(WHO,111,FATAL,B("unable to chdir to ",auto_queue,"/queue/lock"));

  fd = open_write("tcpto");
  if (fd == -1)
    logmsg(WHO,111,FATAL,B("unable to write ",auto_queue,"/queue/lock/tcpto"));
  if (lock_ex(fd) == -1)
    logmsg(WHO,111,FATAL,B("unable to lock ",auto_queue,"/queue/lock/tcpto"));

  buffer_init(&bo,buffer_unixwrite,fd,buf,sizeof(buf));
  for (i = 0; i < sizeof(buf); ++i) 
   buffer_put(&bo,"",1);
  if (buffer_flush(&bo) == -1)
    logmsg(WHO,111,FATAL,B("unable to clear ",auto_queue,"/queue/lock/tcpto"));
  _exit(0);
}
